/*
 *   Copyright (c) 1990 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: Murali. V. Srinivasan
 */

/* #define ASYNC_IO /* */
/* #define DOMAINLOOP /* */

#ifndef lint
static char *sid_xvideo_c = "@(#)xvideo.c	1.14 9/7/90 	Parallax Graphics Inc";
#endif

#define BLOCKSIZE 512

#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/asynch.h>
#include <sys/time.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#ifdef SYSTYPES
#include <sys/types.h>
#endif
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#ifdef ASYNC_IO
#include <sys/asynch.h>
#endif

#include <XPlxExt.h>

#ifndef OPENLOOK
#include <Xm/Xm.h>
/*
#include <X11/Protocols.h>
*/
#include <Xm/Form.h>
#include <Xm/PanedW.h>
#include <Xm/BulletinB.h>
/* Menus */
#include <Xm/RowColumn.h>
#include <Xm/PushBG.h>
#else
#include <Xol/OpenLook.h>
#include <Xol/BulletinBo.h>
#include <Xol/OlClients.h>

static XEvent bull;
static OlWMProtocolVerify omver = {
    OL_WM_DELETE_WINDOW,
    &bull,
};
#endif 	/* OPENLOOK */

extern void exit();

static Widget top, swidget, dwidget;
static Widget popupshell;
static Atom exit_atom;

int videowidth = 320;
int videoheight = 240;
static int sourcewidth, sourceheight, sourcestart;

static Arg args[25];
static unsigned int n;

static short QFactor;

static GC gc, gc1;
static Display *dpy;
static Window win0, win1, twin, pwin;
static int record_flag = -1;
static int print_flag = -1;
static int shm_flag;
static int wait_flag = False;
static int first=1;
static int first1=1;
static int recfd, size;
static XPlxCImage *shmimage = NULL;
static XShmSegmentInfo shminfo;
static XEvent shm_ev;

static struct timeval ts, te;
static int frame_count = 0;
static unsigned long frame_size = 0;
static int max_frame_size = 0;
static int min_frame_size = 0x7fffffff;
static float seconds;

static unsigned char *qt;
static int holdit = 1 ;
static int location;

#ifdef ASYNC_IO
static  aio_result_t aiorslt[256];
static int whichaio = 0;
#endif

char pad_buffer[BLOCKSIZE];
XPlxCImage *pad_image;


/*
 * To clean up when program exit.
 */
static void
exit_func(sig, code, scp)
    int         code;
    int         sig;
    struct sigcontext *scp;
{
    if (shm_flag)
    {
	XShmDetach(dpy, &shminfo);
	shmdt(shminfo.shmid);
	shmctl(shminfo.shmid, IPC_RMID, 0);
    }
    close(recfd);
    exit(0);
}

#ifdef DOMAINLOOP
#ifdef OPENLOOK
static void ehandler(w, cldata, cadata)
Widget w;
caddr_t cldata, *cadata;
#else
static void ehandler(w, cldata, event)
Widget w;
caddr_t cldata;
XClientMessageEvent *event;
#endif
{
    int data = (int) cldata;

#ifdef OPENLOOK
    int type = *((int *) cadata);

    if (type != OL_WM_DELETE_WINDOW)
    {
	omver.msgtype = type;
	OlWMProtocolAction(w, &omver, OL_DEFAULTACTION);
	return;
    }

    if (!data)
	exit_func();
#else /* OPENLOOK */
    {
        if (event->data.l[0] == exit_atom)
            exit_func();
    }
#endif
}
#else /* DOMAINLOOP */
static void ehandler(w, data, event)
caddr_t data;
Widget w;
XEvent *event;
{
    XClientMessageEvent *me;
    if (event->type == ClientMessage && (w == swidget || w == dwidget))
    {
	me = (XClientMessageEvent *)event;
	if (me->data.l[0] == exit_atom)
	    exit_func();
    }
}
#endif

static void exposit(w, data, event)
Widget w;
caddr_t data;
XExposeEvent *event;
{
    if (w == swidget)
	first = 1;
    else
	first1 = 1;
}

static void get_size(dpy, win, w, h, bw)
Display *dpy;
Window win;
int *w, *h, *bw;
{
    XWindowAttributes attrib;

    XGetWindowAttributes(dpy, win, &attrib);
    *w = attrib.width;
    *h = attrib.height;
    *bw = attrib.border_width;
}

static int flag = 0;

static void configit(w, data, event)
Widget w;
caddr_t data;
XEvent *event;
{
    int i, j;
    if ((first == 0) || flag)
    {
	int bw;
	flag = 1;
	get_size(dpy, twin, &videowidth, &videoheight, &bw);

	if (videowidth > sourcewidth)
	    videowidth = sourcewidth;
	if (videoheight > sourceheight)
	    videoheight = sourceheight;
	if (((videowidth * 3) / 4) > ((videoheight * 4) / 3))
	    videoheight = (videowidth * 3) / 4;
	else
	    videowidth = (videoheight * 4) / 3;

	XtResizeWidget(top, videowidth, videoheight, bw);
	XtResizeWidget(swidget, videowidth, videoheight, bw);
	XtResizeWidget(popupshell, videowidth, videoheight, bw);
	XtResizeWidget(dwidget, videowidth, videoheight, bw);
	first = first1 = 1;
    }
}

static int loopflag = 0;

static void buttonp(w, data, event)
Widget w;
caddr_t data;
XButtonEvent *event;
{
    if (w == dwidget)
    {
	loopflag = !loopflag;
	return;
    }
    if (record_flag < 0)
	record_flag = 0;
    record_flag = !record_flag;
    if (!record_flag)
    {
#ifdef ASYNC_IO
	aiowait(0);
	aiowait(0);
	lseek(recfd, location, SEEK_SET );
#endif
	pad_image->size = 0 ;
	if (write(recfd, pad_image, BLOCKSIZE) == -1)
	{
	    perror("END MARKER");
	    exit(-1);
	}
	/*
	 * End of recording, print out statistic
	 */
	gettimeofday(&te, 0);
	seconds = (float) (te.tv_sec - ts.tv_sec) +
		  ((float) (te.tv_usec - ts.tv_usec) / (float) 1000000);
	printf("Recording:\n");
	printf("        %f frames per second\n", ((float) frame_count) / seconds);
	printf("        %f bytes per second\n", ((float) frame_size) / seconds);
	printf("        %d bytes maximum frame size\n", max_frame_size);
	printf("        %f bytes average frame size\n", ((float) frame_size) / frame_count);
	printf("        %d bytes minimum frame size\n", min_frame_size);
	/*
	 * Start replaying statistic.
	 */
	frame_count = 0;
	frame_size = 0;
	print_flag = !print_flag;
	gettimeofday(&ts, 0);
    }
    else
    {
	if (shm_flag && wait_flag)
	{
	    /*
	     * Wait for the done event for last share memory put image.
	     */
#ifdef HACK
	    struct timeval tmps, tmpe;
	    float sec;
	    int ctl_flag = TRUE;

	    gettimeofday(&tmps, 0);
	    while (ctl_flag)
	    {
		if (!XCheckTypedWindowEvent(dpy, win1,
		    XShmGetEventBase(dpy) + ShmCompletion, &shm_ev))
		{
		    gettimeofday(&tmpe, 0);
		    sec = (float) (tmpe.tv_sec - tmps.tv_sec) +
			((float) (tmpe.tv_usec - tmps.tv_usec) / (float) 1000000);
		    if (sec >= 10)
		    {
			printf ("failed to get ShmCompletion event\n");
			ctl_flag = FALSE;
		    }
		}
		else
		    ctl_flag = FALSE;
	    }
#endif
	    while (!XCheckTypedWindowEvent(dpy, win1,
		XShmGetEventBase(dpy) + ShmCompletion, &shm_ev));
	    wait_flag = False;
	}
	/*
	 * Start recording statistic.
	 */
	frame_count = 0;
	frame_size = 0;
	max_frame_size = 0;
	min_frame_size = 0x7fffffff;
	gettimeofday(&ts, 0);
    }
    if (lseek(recfd, 0L, SEEK_SET ) < 0)
    {
	perror("SEEK");
	exit(-1);
    } 
    first = 1;
    first1 = 1;
    location = 0;
}

#ifdef DOMAINLOOP
worker_shm(data)
caddr_t data;
#else
worker_shm()
#endif
{
    int i, count;

    if (record_flag < 0)
	return(FALSE);

    if (first)
	XPlxVideoTag(dpy, win0, gc, PLX_VIDEO);
    if (first1)
	XPlxVideoTag(dpy, win1, gc1, PLX_VIDEO);

    if (record_flag)
    {
	XPlxVideoSqueezeStill(dpy, win0, gc, 0, sourcestart, sourcewidth,
			 sourceheight, 0, 0, videowidth, videoheight);
	shmimage->width = videowidth;
	shmimage->height = videoheight;

#ifdef ASYNC_IO
	if (location)
	{
	    aiowait(0);
	    aiowait(0);
	}
#endif
	XPlxShmGetCImage(dpy, win0, gc, shmimage, 0, 0, videowidth,
			 videoheight, videowidth, videoheight);

	*pad_image = *shmimage ;
#ifdef ASYNC_IO
	if ((i = aiowrite(recfd, pad_image, BLOCKSIZE, location,
			  0, &aiorslt[whichaio])) < 0)
#else
	if (write(recfd, pad_image, BLOCKSIZE) < 0)
#endif
	{
	    perror("W-HDR");
	    exit(-1);
	}

#ifdef ASYNC_IO
	whichaio = (whichaio + 1) & 0xff;
	location += BLOCKSIZE;
	if ((i = aiowrite(recfd, shmimage->data, ((shmimage->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1)), location,
			  0, &aiorslt[whichaio])) < 0)
#else
	if (write(recfd, shmimage->data, ((shmimage->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1))) < 0)
#endif
	{
	    perror("W-IMAGE");
	    exit(-1);
	}

#ifdef ASYNC_IO
	whichaio = (whichaio + 1) & 0xff;
	location += ((shmimage->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1));
#endif

	if (shmimage->size > max_frame_size)
	    max_frame_size = shmimage->size;
	if (shmimage->size < min_frame_size)
	    min_frame_size = shmimage->size;
	frame_size += shmimage->size;
	frame_count++;
    }
    else
    {
	if (!wait_flag)
	    wait_flag = True;
	else
	{
	    /*
	     * Wait for the done event for last share memory put image.
	     */
#ifdef HACK
	    struct timeval tmps, tmpe;
	    float sec;
	    int ctl_flag = TRUE;

	    gettimeofday(&tmps, 0);
	    while (ctl_flag)
	    {
		if (!XCheckTypedWindowEvent(dpy, win1,
		    XShmGetEventBase(dpy) + ShmCompletion, &shm_ev))
		{
		    gettimeofday(&tmpe, 0);
		    sec = (float) (tmpe.tv_sec - tmps.tv_sec) +
			((float) (tmpe.tv_usec - tmps.tv_usec) / (float) 1000000);
		    if (sec >= 10)
		    {
			printf ("failed to get ShmCompletion event\n");
			ctl_flag = FALSE;
		    }
		}
		else
		    ctl_flag = FALSE;
	    }
#endif
	    while (!XCheckTypedWindowEvent(dpy, win1,
		XShmGetEventBase(dpy) + ShmCompletion, &shm_ev));
	}

	count = read(recfd, pad_image, BLOCKSIZE);
	if (count != BLOCKSIZE)
	{
	    perror("HDR");
	    exit(-1);
	}
	*shmimage = *pad_image ;
	if (shmimage->size == 0)
	{
	    /*
	     * End of replaying, print out statistic.
	     */
	    if (!print_flag)
	    {
		gettimeofday(&te, 0);
		seconds = (float) (te.tv_sec - ts.tv_sec) +
			  ((float) (te.tv_usec - ts.tv_usec) / (float) 1000000);
		printf("Replaying:\n");
		printf("        %f frames per second\n", ((float) frame_count) / seconds);
		printf("        %f bytes per second\n", ((float) frame_size) / seconds);
		print_flag = !print_flag;
	    }

	    wait_flag = False;
	    if (loopflag)
		lseek(recfd, 0, 0);
	    else
		record_flag = -1;

	    return(FALSE);
	}

	count = read(recfd, shmimage->data, ((shmimage->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1)));
	if (count != ((shmimage->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1)))
	{
	    perror("IMAGE");
	    exit(-1);
	}

	frame_size += shmimage->size;
	frame_count++;

	XPlxShmPutCImage(dpy, win1, gc1, shmimage, 0, 0, videowidth,
		videoheight, 0, 0,  videowidth, videoheight, 0, True);
    } 

    if (first)
    {
	XPlxVideoTag(dpy, win0, gc, PLX_VIDEO_OVR);
	first = 0;
    }

    if (first1)
    {
	XPlxVideoTag(dpy, win1, gc1, PLX_VIDEO_OVR);
	first1 = 0;
    }

    return(FALSE);
}

#ifdef DOMAINLOOP
worker_nonshm(data)
caddr_t data;
#else
worker_nonshm()
#endif
{
    static XPlxCImage *image = NULL, recimage;
    XPlxCImage *timage;
    int i, count;
    char ibuf[0x10000];

    if (record_flag < 0)
	return(FALSE);

    if (first)
	XPlxVideoTag(dpy, win0, gc, PLX_VIDEO);
    if (first1)
	XPlxVideoTag(dpy, win1, gc1, PLX_VIDEO);

    if (record_flag)
    {
	timage = image;
	XPlxVideoSqueezeStill(dpy, win0, gc, 0, sourcestart, sourcewidth,
			 sourceheight, 0, 0, videowidth, videoheight);
	image = (XPlxCImage *) XPlxGetCImage(dpy, win0, gc, 0, 0,
			videowidth, videoheight, videowidth, videoheight);
#ifdef ASYNC_IO
	if (timage)
	{
	    aiowait(0);
	    aiowait(0);
	    XPlxDestroyCImage(timage);
	}
#endif
	*pad_image = *image;
#ifdef ASYNC_IO
	if((i = aiowrite(recfd, pad_image, BLOCKSIZE, location,
			 0, &aiorslt[whichaio])) < 0)
#else
	if (write(recfd, pad_image, BLOCKSIZE) < 0)
#endif
	{
	    perror("W-HDR");
	    exit(-1);
	}
#ifdef ASYNC_IO
	whichaio = (whichaio + 1) & 0xff;
	location += BLOCKSIZE;
	if((i = aiowrite(recfd, image->data, ((image->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1)),location,
			 0, &aiorslt[whichaio])) < 0)
#else
	if (write(recfd, image->data, ((image->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1))) < 0)
#endif
	{
	    perror("W-IMAGE");
	    exit(-1);
	}

	if (image->size > max_frame_size)
	    max_frame_size = image->size;
	if (image->size < min_frame_size)
	    min_frame_size = image->size;
	frame_size += image->size;
	frame_count++;

#ifdef ASYNC_IO
	whichaio = (whichaio + 1) & 0xff;
	location += ((image->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1));
#else
	XPlxDestroyCImage(image);
#endif
    }
    else
    {
	count = read(recfd, pad_image, BLOCKSIZE);

	if (count != BLOCKSIZE)
	{
	    perror("HDR");
	    exit(-1);
	}
	recimage = *pad_image ;

	recimage.data = ibuf;

	if (recimage.size == 0)
	{
	    /*
	     * End of replaying, print out statistic.
	     */
	    if (!print_flag)
	    {
		gettimeofday(&te, 0);
		seconds = (float) (te.tv_sec - ts.tv_sec) +
			  ((float) (te.tv_usec - ts.tv_usec) / (float) 1000000);
		printf("Replaying:\n");
		printf("        %f frames per second\n", ((float) frame_count) / seconds);
		printf("        %f bytes per second\n", ((float) frame_size) / seconds);
		print_flag = !print_flag;
	    }

	    if (loopflag)
		lseek(recfd, 0, 0);
	    else
		record_flag = -1;

	    return(FALSE);
	}

	count = read(recfd, recimage.data, ((recimage.size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1)));

	if (count != ((recimage.size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1)))
	{
	    perror("IMAGE");
	    exit(-1);
	}

	frame_size += recimage.size;
	frame_count++;

	XPlxPutCImage(dpy, win1, gc1, &recimage, 0, 0, videowidth,
		 videoheight, 0, 0,  videowidth, videoheight);
    }

    if (first)
    {
	XPlxVideoTag(dpy, win0, gc, PLX_VIDEO_OVR);
	first = 0;
    }

    if (first1)
    {
	XPlxVideoTag(dpy, win1, gc1, PLX_VIDEO_OVR);
	first1 = 0;
    }

    return(FALSE);
}

static void usage(c)
char *c;
{
    printf("usage: %s [-q #] [-f filename] [-n]\n", c);
    exit(1);
}

void main(argc, argv)
int argc;
char **argv;
{
    plx_IO *plxio;
    plx_IO_list *iolist;
    plx_signal_list *siglist;
    plx_signal *sig;
    int i, tmp, badsync;
    char *name1 = ":0.0";
    char *name2 = "unix:0.0";
    char *msg = "Fail to create shared memory, it is running on non-shared memory\n";
    static char *filename = "/tmp/theimage";
    static int mask = ButtonPressMask | ExposureMask;
    static int mask1 = StructureNotifyMask;
    static int (*worker)() = worker_nonshm;

    pad_image = (XPlxCImage *)pad_buffer;
    shm_flag = True;
    QFactor = 100; /* default valuse */

    /*
     * install signal handler for kill and crahses.
     */
    signal (SIGINT, exit_func);
    signal (SIGSEGV, exit_func);
    signal (SIGBUS, exit_func);

    /*
     * command line option to overrride the default
     * value of the QFactor and filename. The -n
     * option is for turning off shared memory.
     */
    for (i = 1; i < argc; ++i)
    {
	if (strcmp("-q", argv[i]) == 0)
	{
	    if (sscanf(argv[++i], "%d", &tmp) != 1)
		usage(argv[0]);
	    QFactor = tmp;
	}
	else if (strcmp("-f", argv[i]) == 0)
	    filename = argv[++i];
	else if(strcmp("-n", argv[i]) == 0)
	    shm_flag = False;
	else
	    usage(argv[0]);
    }

    /*
     * make the q tables. if you change the qfactor you must call
     * MakeQtables
     */

    size = MakeQTables(QFactor, &qt);

    n = 0;
    XtSetArg(args[n], XtNborderWidth, 0); n ++;
    XtSetArg(args[n], XtNwidth, videowidth); n ++;
    XtSetArg(args[n], XtNheight, videoheight); n++;

#ifdef OPENLOOK
    top = OlInitialize("xvideo", "XVideo", NULL, 0, &argc, argv);
#else
    top = XtInitialize("xvideo", "XVideo", NULL, 0, &argc, argv);
#endif

    popupshell = XtAppCreateShell("destination","Compress",
			applicationShellWidgetClass, XtDisplay(top), NULL, 0);

    n = 0;
#ifdef OPENLOOK
    XtSetArg(args[n], XtNborderWidth, 0); n ++;
    XtSetArg(args[n], XtNwidth, videowidth); n ++;
    XtSetArg(args[n], XtNheight, videoheight); n++;
    swidget = XtCreateManagedWidget("src", bulletinBoardWidgetClass, top,
			args, n);
    dwidget = XtCreateManagedWidget("dest", bulletinBoardWidgetClass,
			popupshell, args, n);
#else
#endif

    /*
     * all set up, let her fly.
     */
    XtRealizeWidget(top);
    XtRealizeWidget(popupshell);

    dpy = XtDisplay(swidget);
    twin = XtWindow(top);
    pwin = XtWindow(popupshell);
    win0 = XtWindow(swidget);
    win1 = XtWindow(dwidget);
    gc = XCreateGC(dpy, win0, 0, 0);
    gc1 = XCreateGC(dpy, win1, 0, 0);
    XSetForeground(dpy, gc, 0);
    XSetForeground(dpy, gc1, 0);

    /* store qtables for compress and decompress in the GCs */
    XPlxPutTable(dpy, win0, gc, qt, size, 0);
    XPlxPutTable(dpy, win1, gc1, qt, size, 1);

    if (shm_flag &&
	((strncmp (name1, dpy->display_name, strlen(name1)) == 0) ||
	(strncmp (name2, dpy->display_name, strlen(name2)) == 0)))
    {
	tmp = XShmGetEventBase(dpy) + ShmCompletion;
	shminfo.shmid = shmget(IPC_PRIVATE, 256 * 1024, IPC_CREAT|0777);
	if (shminfo.shmid < 0)
	{
	    perror(msg);
	    shm_flag = False;
	}
	else
	{
	    shminfo.shmaddr = (char *)shmat(shminfo.shmid, 0, 0);
	    if (shminfo.shmaddr == ((char *)-1))
	    {
		perror(msg);
	        shm_flag = False;
	    }
	    else
	    {
		shmimage = (XPlxCImage *)XPlxShmCreateCImage(dpy, shminfo.shmaddr,
						 &shminfo, 0, 0, 0);
		shminfo.readOnly = False;
		XShmAttach(dpy, &shminfo);
		worker = worker_shm;
	    }
	}
    }

    if ((recfd = open(filename, O_RDWR | O_CREAT)) < 0) {
	perror(filename);
	exit(-1);
    }
    unlink(filename);

#ifdef DOMAINLOOP
    XtAddEventHandler(swidget, ButtonPressMask, False, buttonp, NULL);
    XtAddEventHandler(dwidget, ButtonPressMask, False, buttonp, NULL);
    XtAddEventHandler(swidget, StructureNotifyMask, False, configit, NULL);
    XtAddEventHandler(swidget, ExposureMask, False, exposit, NULL);
    XtAddEventHandler(dwidget, ExposureMask, False, exposit, NULL);
#ifdef OPENLOOK
    OlAddCallback(top, XtNwmProtocol, ehandler, NULL);
    OlAddCallback(popupshell, XtNwmProtocol, ehandler, NULL);
#else
    XtAddEventHandler(top, 0, False, ehandler, NULL);
    XtAddEventHandler(popupshell, 0, False, ehandler, NULL);
#endif
    XtAddWorkProc(worker, NULL);
#endif
    exit_atom = XInternAtom(dpy, "WM_DELETE_WINDOW", False);
#ifndef OPENLOOK
#ifdef notdef
    XmAddWMProtocols (top, &exit_atom, 1);
#endif
    XSetWMProtocols(dpy, win0, &exit_atom, 1);
    XSetWMProtocols(dpy, win1, &exit_atom, 1);
#endif

    /*
     * query the server to get hardware/signal information.
     */
    plxio = (plx_IO *) XPlxQueryConfig(dpy, win0, gc);

    /* if the hardware type is not XVideo, can't work */
    if(plxio->hardware != PLX_XVIDEO_24)
    {
	printf("%s can only run on Parallax XVideo hardware\n", argv[0]);
	exit(1);
    }

    /* find a pointer to channel one input */
    for (iolist = plxio->inputs;
	 iolist && (iolist->channel != PLX_INPUT_0);
	 iolist = iolist->next_IO); /* has to work, can't fail */

    /* go through the list of signals and find an active signal */
    badsync = 1;
    for (siglist = iolist->signal_list; siglist;
	siglist = siglist->next_signal)
    {
	/*
	 * do an input select
	 * we are only using input 0 so it, and PLX_COMP are hard coded
	 * we also know that all the XVideo hardware can do is PLX_RGB24
	 */
	XPlxVideoInputSelect(dpy, win0, gc, PLX_INPUT_0,
				siglist->signal->standard,
				PLX_COMP, PLX_RGB24);

	/* now do a query video to find out if there is sync */
	sig = (plx_signal *) XPlxQueryVideo(dpy, win0, gc);
	if (sig->sync_ok)
	{
	    badsync = 0;
	    break;
	}
    }

    if (badsync)
    {
	printf("no video connected to input 0\n");
	exit(1);
    }

    sourcewidth = sig->w;
    tmp = (sig->w * 3) / 4;
    sourceheight = tmp;
    tmp = sig->h - tmp;
    sourcestart = tmp + 1;

#ifdef DOMAINLOOP
    XtMainLoop();
#else
    XSelectInput(dpy, win0, mask);
    XSelectInput(dpy, win1, mask);
    while(1)
    {
	XEvent event;
	XExposeEvent *xevent;
	XConfigureEvent *cevent;
	XClientMessageEvent *mevent;

	if (record_flag >= 0)
	    worker();

	if (XPending(dpy))
	{
	    if (XCheckWindowEvent(dpy, win0, mask, &event))
	    {
		if (event.type == ButtonPress)
		    buttonp(swidget, 0, &event);
		else
		    first = 1;
		continue;
	    }

	    if (XCheckWindowEvent(dpy, win1, mask, &event))
	    {
		if (event.type == ButtonPress)
		    loopflag = !loopflag;
		else
		    first1 = 1;
		continue;
	    }

	    if (XCheckWindowEvent(dpy, twin, mask1, &event))
	    {
		configit(swidget, 0, &event);
		continue;
	    }

	    if (XCheckTypedWindowEvent(dpy, twin, ClientMessage, &event))
	    {
		mevent = (XClientMessageEvent *)&event;
		if (mevent->data.l[0] == exit_atom)
		    exit_func();
	    }

	    if (XCheckTypedWindowEvent(dpy, pwin, ClientMessage, &event))
	    {
		mevent = (XClientMessageEvent *)&event;
		if (mevent->data.l[0] == exit_atom)
		    exit_func();
	    }
	}
    }
#endif
}
